MAPIClientLibraries 2.0 API Documentation

- Main Page
- Related Pages
- Data Structures
- Files
- Examples

- File List
- Globals

Functions
freebusy.c File Reference

Convenient API to access FreeBusy. More...

`#include "libmapi/libmapi.h"`
`#include "libmapi/libmapi_private.h"`
`#include <ctype.h>`

## Functions
_PUBLIC_ int | GetFreeBusyYear (const uint32_t *publish_start)
_PUBLIC_ enum MAPISTATUS | GetUserFreeBusyData (mapi_object_t *obj_store, const char *recipient, struct SRow *pSRow)
_PUBLIC_ enum MAPISTATUS | IsFreeBusyConflict (mapi_object_t *obj_store, struct FILETIME *date, bool *conflict)

## Detailed Description

Convenient API to access FreeBusy.

## Function Documentation

_PUBLIC_ int GetFreeBusyYear | ( | const uint32_t * | publish_start | ) |

Return the year associated with the FreeBusy start range

Parameters

  publish_start | pointer to the publish start integer

Returns
  a valid year on success, otherwise 0

Referenced by IsFreeBusyConflict().

_PUBLIC_ enum MAPISTATUS GetUserFreeBusyData | ( | mapi_object_t * | obj_store,
|  | const char * | recipient,
|  | struct SRow * | pSRow
| ) |  |

Retrieve FreeBusy data associated with the specified recipient

Parameters

  obj_store | pointer to the public folder MAPI object
  recipient | name of the recipient to fetch freebusy data
  pSRow | pointer to the returned properties

Note
  The function returns a SRow structure with the following property tags:
  1. PR_NORMALIZED_SUBJECT
  2. PR_FREEBUSY_RANGE_TIMESTAMP
  3. PR_FREEBUSY_PUBLISH_START
  4. PR_FREEBUSY_PUBLISH_END
  5. PR_SCHDINFO_MONTHS_MERGED
  6. PR_SCHDINFO_FREEBUSY_MERGED
  7. PR_SCHDINFO_MONTHS_TENTATIVE
  8. PR_SCHDINFO_FREEBUSY_TENTATIVE
  9. PR_SCHDINFO_MONTHS_BUSY
  10. PR_SCHDINFO_FREEBUSY_BUSY
  11. PR_SCHDINFO_MONTHS_OOF
  12. PR_SCHDINFO_FREEBUSY_OOF

Returns
  MAPI_E_SUCCESS on success, otherwise MAPI error

References FindRow(), GetABRecipientInfo(), GetContentsTable(), GetDefaultPublicFolder(), GetHierarchyTable(), GetProps(), mapi_object_get_session(), mapi_object_init(), mapi_object_release(), MAPIFreeBuffer(), OpenFolder(), OpenMessage(), set_SPropTagArray(), SetColumns(), and SortTable().

Referenced by IsFreeBusyConflict().

_PUBLIC_ enum MAPISTATUS IsFreeBusyConflict | ( | mapi_object_t * | obj_store,
|  | struct FILETIME * | date,
|  | bool * | conflict
| ) |  |

Check if a date conflicts with existing FreeBusy Busy/Out Of Office events

Parameters

  obj_store | pointer to the public folder MAPI object
  date | pointer to the date to check
  conflict | pointer to the returned boolean value

Returns
  MAPI_E_SUCCESS on success, otherwise MAPI error

References GetFreeBusyYear(), GetUserFreeBusyData(), and mapi_object_get_session().

| This content is licensed under the Creative Commons Attribution ShareAlike License v. 3.0: http://creativecommons.org/licenses/by-sa/3.0/